Nativefier/bin/pngToIcns

85 lines
2.5 KiB
Plaintext
Raw Normal View History

#!/bin/sh
2016-03-10 08:41:25 +01:00
### USAGE
# ./pngToIcns <input png> <outp icns>
# Example
# ./pngToIcns.sh ~/sample.png ~/Desktop/converted.icns
2016-03-10 08:41:25 +01:00
# exit the shell script on error immediately
set -e
# import script as variable
CONVERT_TO_PNG="${BASH_SOURCE%/*}/convertToPng"
# Exec Paths
ICONUTIL=$(which iconutil)
2016-03-09 07:22:11 +01:00
IMAGEMAGICK_CONVERT=$(which convert)
IMAGEMAGICK_IDENTIFY=$(which identify)
if [ ! -x "${ICONUTIL}" ]; then
echo "Cannot find required iconutil executable" >&2
exit 1;
fi
2016-03-09 07:22:11 +01:00
if [ ! -x "${IMAGEMAGICK_CONVERT}" ]; then
echo "Cannot find required ImageMagick Convert executable" >&2
exit 1;
fi
2016-03-09 07:22:11 +01:00
if [ ! -x "${IMAGEMAGICK_IDENTIFY}" ]; then
echo "Cannot find required ImageMagick Identify executable" >&2
exit 1;
fi
# Parameters
SOURCE=$1
2016-02-04 07:43:08 +01:00
DEST=$2
# Check source and destination arguments
if [ -z "${SOURCE}" ]; then
echo "No source image specified"
exit 1
fi
2016-02-04 07:43:08 +01:00
if [ -z "${DEST}" ]; then
echo "No destination specified"
exit 1
fi
# File Infrastructure
NAME=$(basename "${SOURCE}")
EXT="${NAME##*.}"
BASE="${NAME%.*}"
2016-03-10 08:41:25 +01:00
TEMP_DIR="temp_icon"
ICONSET="${BASE}.iconset"
2016-03-10 08:41:25 +01:00
function cleanUp() {
rm -rf "${TEMP_DIR}"
rm -rf "${ICONSET}"
}
2016-03-10 08:41:25 +01:00
trap cleanUp EXIT
2016-03-10 08:41:25 +01:00
mkdir -p "${TEMP_DIR}"
mkdir -p "${ICONSET}"
2016-03-10 08:41:25 +01:00
PNG_PATH="${TEMP_DIR}/icon.png"
${CONVERT_TO_PNG} "${SOURCE}" "${PNG_PATH}"
# Resample image into iconset
2016-03-10 08:41:25 +01:00
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 16x16 "${ICONSET}/icon_16x16.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 32x32 "${ICONSET}/icon_16x16@2x.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 32x32 "${ICONSET}/icon_32x32.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 64x64 "${ICONSET}/icon_32x32@2x.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 128x128 "${ICONSET}/icon_128x128.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 256x256 "${ICONSET}/icon_128x128@2x.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 256x256 "${ICONSET}/icon_256x256.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 512x512 "${ICONSET}/icon_256x256@2x.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 512x512 "${ICONSET}/icon_512x512.png"
convert "${PNG_PATH}" -define png:big-depth=16 -define png:color-type=6 -sample 1024x1024 "${ICONSET}/icon_512x512@2x.png"
# Create an icns file lefrom the iconset
2016-03-09 07:22:11 +01:00
iconutil -c icns "${ICONSET}" -o "${DEST}"
2016-03-10 08:41:25 +01:00
trap - EXIT
cleanUp